#include "punct_stream.h"
#include <algorithm>
#include <iomanip>
#include <iostream>
#include <sstream>

using namespace std;

void inplace_decrypt(string &word, const string &letters, const int shift) {
  int new_i = 0;
  int size = letters.size();
  for (char &c : word) {
    for (int i = 0; i < size; i++) {
      new_i = (i + shift) % size;
      if (letters[new_i] == c) {
        c = letters[i];
        break;
      }
    }
  }
}

int main() {
  string letters = ("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
  transform(letters.begin(), letters.end(), letters.begin(),
            [](unsigned char c) { return tolower(c); });

  string message = "SURJUDPV PXVW EH ZULWWHQ IRU SHRSOH WR UHDG, DQG RQOB "
                   "LQFLGHQWDOOB IRUPDFKLQHV WR HAHFXWH.\n";
  stringstream ins;
  ins.str(message);

  Punct_stream ps{ins};
  ps.whitespace(";:,.?!()\"{}<>/&$@#%^*|~"); // note \“ means ” in string
  ps.case_sensitive(false);
  // cout << "please enter words (ctrl-D to terminate)\n";

  vector<string> vs;
  for (string word; ps >> word;)
    vs.push_back(word);

  for (int s = 0; s < letters.size(); s++) {
    stringstream sentence;
    for (string word : vs) {
      inplace_decrypt(word, letters, s);
      sentence << word << " ";
    }
    cout << "shift:" << setw(3) << s << " " << sentence.str() << endl;
  }
}
